/*			Fenster V 2.00
		(c) 1995 - 2003 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen
			
		Abgespeckte Version fr In2Cat
			
		Dieses File ist Teil des In2Cat-Projektes und steht unter der
		In2Cat Public License. Dementspechend ist es Freeware und darf
		entsprechend der o.g. Liscense weitergegeben und verndert werden.
		Eine Kopie der In2Cat Public License liegt diesem Paket bei
		Diese Copyright Meldung darf nur vom Copyright Inhaber gendert werden.
*/

/* fr neues form_do:
	alt:	void blabla(void)
			{	block1
				do
				{	block2
					but=form_do
					switch(but)
					{	block3
					}
				}
				block4
			}
	neu:	void blabla(but)
			swich(but)
			{	case -1:
					if(fenst_4_obj<0
						return
					block1
				block3
			}
			if(weiter)
			{	block2
				fdw_ini
			}
			else
				block4

Initialisierungs Aufruf mit -1
wind_delete,wind_close,entf_fenster,form_dial durch del_fenst_4_obj ersetzen
draw_obj durch redraw ersetzen
*/



/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */
#include "fenster.h"
#include "easyfsel.h"
#include <scancode.h>
#include <string.h>
#include <stdlib.h>
/* -------------------------------------------------------------------- */
/*		typedefs														*/
/* -------------------------------------------------------------------- */


/* -------------------------------------------------------------------- */
/* 		lokale Funktionsprototypen										*/
/* -------------------------------------------------------------------- */

int rc_intersect(GRECT *p1,GRECT *p2);
void do_redraw(OBJECT *tree,int fenster,int x,int y,int w,int h);
void do_move_4obj(FENSTER *fenst, int x, int y);
int find_object(OBJECT *tree,int start_object,int which);
void set_top_win(int hdl);
void icon_draw(FENSTER *fenst,GRECT *box);
void find_avserv(void);
int fehler_fe(char *meldung,int fehler);
int meld_def(char *meldung,int fehler);

/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */
#define FMD_BACKWARD 	-1
#define FMD_FORWARD 	-2
#define FMD_DEFLT 		-3
#define WM_ISTOP 		43
#define	G_m_size		256
#define USR_STORED		28100

/* -------------------------------------------------------------------- */
/*		Globale Variablen												*/
/* -------------------------------------------------------------------- */

int Prozent_esc=0;
PROT_INF Prot_inf;
GEM_INF Gem_inf;
int (*Meldungen[7])(char *ziel,int fehler)={meld_def,meld_def,meld_def,meld_def,meld_def,meld_def,meld_def};

/* -------------------------------------------------------------------- */
/*		Funktionen														*/
/* -------------------------------------------------------------------- */
/* Parameter:	gem_i: gm_name mu mit dem Programmnamen gesetzt sein
				nur_aes: na was wohl
				my_name: Name des PRG, oder NULL wenn nicht erster Aufruf
	Rckgabe:	gem_i: gm_ahdl, gm_vhdl,gm_bm,gm_dsk werden gesetzt
				Rckgabewert: 	0: S/W
								>0 farbig
								<0 Fehlercode
*/
int init_fenster(char *my_name)
{  	int handle,farbig=1;
	int int_in[11]= {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2};
	int int_out[57];
	int dummy;
	MFDB *bilds;
	set_errm(ERR_FENSTER,fehler_fe);
	if(my_name)
	{	if((Gem_inf.gm_name=my_mxalloc(9,MXTTST|MXGLOB))==NULL)
			return(ERR_FE_SPEI);
		strncpy(Gem_inf.gm_name,my_name,8);
		Gem_inf.gm_name[8]='\0';
		while(strlen(Gem_inf.gm_name)!=8)
			strcat(Gem_inf.gm_name," ");
	}
/*DYJ 2.06d Start*/
	bilds=Gem_inf.gm_dsk=malloc(sizeof(MFDB));
	/* Programm anmelden */
	Gem_inf.gm_ahdl=appl_init();
	graf_mouse(0,NULL);
	wind_update(BEG_UPDATE);
/*DYJ  Ende; alt:	
	wind_update(BEG_UPDATE);
	bilds=Gem_inf.gm_dsk=malloc(sizeof(MFDB));
	/* Programm anmelden */
	Gem_inf.gm_ahdl=appl_init();
*/

	handle=graf_handle(&dummy,&dummy,&dummy,&dummy);
  	v_opnvwk(int_in,&handle,int_out);
  	bilds->fd_w=int_out[0]+1;

  	bilds->fd_h=int_out[1]+1;
  	if(!int_out[35])
		farbig=0;
  	bilds->fd_addr=NULL;
  	vq_extnd(handle,1,int_out);
  	bilds->fd_nplanes=int_out[4];
		
  	Gem_inf.gm_vhdl=handle;
	
	wind_update(END_UPDATE);
	find_avserv();
	return(farbig);
}
/*	AV_Server ermitteln	*/
void find_avserv(void)
{	char *av_server,lst_server[ANZ_AVSERV+1][9]={"",AV_SERVER};
	int start=1,i;
/* 1. Environmentvariable	*/
	if((av_server=getenv("AVSERVER"))!=NULL)
	{	start=0;
		strncpy(lst_server[0],av_server,9);
		lst_server[0][8]='\0';
		while(strlen(lst_server[0])<8)
			strcat(lst_server[0]," ");
		av_server=strupr(lst_server[0]);
		if(av_server!=lst_server[0])
			strcpy(lst_server[0],av_server);
	}
	
/* 2. Im Zweifelsfall 0	*/
	Prot_inf.id_avserv=0;
/* 3. Bekannte Server suchen	*/
	for(i=start;i<=ANZ_AVSERV;i++)
	{	if((Prot_inf.id_avserv=appl_find(lst_server[i]))>-1)
			break;
	}
	send_av_prot();
	Prot_inf.id_avserv=-1;	/* Warten auf Antwort	*/
}
void exit_fenster(void)
{
  	v_clsvwk(Gem_inf.gm_vhdl);
	/* Programm abmelden */
	appl_exit();
}

/* Schnittflche zweier Rechtecke bilden. Der Returnwert ist genau 
	dann Null, wenn sich die rechtecke nicht berschneiden. Die
	zweite GRECT-Struktur wird mit den Koordinaten der Schnittflche
	berschrieben */
int rc_intersect(GRECT *p1,GRECT *p2)
{	int tx,ty,tw,th;
	tw=min(p2->g_x +p2->g_w,p1->g_x+p1->g_w);
	th=min(p2->g_y +p2->g_h,p1->g_y+p1->g_h);
	tx=max(p2->g_x,p1->g_x);
	ty=max(p2->g_y,p1->g_y);
	p2->g_x=tx;
	p2->g_y=ty;
	p2->g_w=tw-tx;
	p2->g_h=th-ty;
	return(p2->g_w>0 && p2->g_h>0);
}
void wind_sized(GRECT *rect,FENSTER *fenst)
{	int x1,y1,w1,h1;
	wind_calc(WC_WORK,fenst->f_k,rect->g_x,rect->g_y,rect->g_w,rect->g_h,
		&fenst->f_ax,&fenst->f_ay,&fenst->f_aw,&fenst->f_ah);
	if(fenst->f_aw>fenst->f_vb.mfdbx[0].fd_w)
		fenst->f_aw=fenst->f_vb.mfdbx[0].fd_w;
	if(fenst->f_ah>fenst->f_vb.mfdbx[0].fd_h)
		fenst->f_ah=fenst->f_vb.mfdbx[0].fd_h;
	wind_calc(WC_BORDER,fenst->f_k,fenst->f_ax,fenst->f_ay,fenst->f_aw,fenst->f_ah,
				&x1,&y1,&w1,&h1);
	wind_set(fenst->f_hdl,WF_CURRXYWH,x1,y1,w1,h1);
	fenst->f_sldh[5]=d_satz(fenst->f_aw,fenst->f_vb.mfdbx[0].fd_w-1,1000);
	fenst->f_sldv[1]=d_satz(fenst->f_ah,fenst->f_vb.mfdbx[0].fd_h-1,1000);
	wind_set(fenst->f_hdl,WF_HSLSIZE,fenst->f_sldh[5],0,0,0);
	wind_set(fenst->f_hdl,WF_VSLSIZE,fenst->f_sldv[1],0,0,0);
	if(fenst->f_sldh[5]==1000)
		fenst->f_sldh[5]=0;
	else
	{	fenst->f_sldh[5]=(int)((float)fenst->f_sldh[5]/(1.-(float)fenst->f_sldh[5]/1000));
		if(fenst->f_sldh[5]>1000)fenst->f_sldh[5]=1000;
	}
	if(fenst->f_sldv[1]==1000)
		fenst->f_sldv[1]=0;
	else
	{	fenst->f_sldv[1]=(int)((float)fenst->f_sldv[1]/(1.-(float)fenst->f_sldv[1]/1000));
		if(fenst->f_sldv[1]>1000)fenst->f_sldv[5]=1000;
	}
	fenst->f_sldh[4]=-fenst->f_sldh[5];
	fenst->f_sldv[0]=-fenst->f_sldv[1];
	fenst->f_sldh[6]=-fenst->f_sldh[5]/8;
	fenst->f_sldv[2]=-fenst->f_sldv[1]/8;
	fenst->f_sldh[7]=fenst->f_sldh[5]/8;
	fenst->f_sldv[3]=fenst->f_sldv[1]/8;
	fenst->f_ox+=fenst->f_ax;
	fenst->f_oy+=fenst->f_ay;
	if(fenst->f_ox+fenst->f_aw>fenst->f_vb.mfdbx[0].fd_w)
		fenst->f_ox=fenst->f_vb.mfdbx[0].fd_w-fenst->f_aw;
	if(fenst->f_vb.mfdbx[0].fd_w-fenst->f_aw)
		fenst->f_slh=(int)(((long)fenst->f_ox*1000)/(fenst->f_vb.mfdbx[0].fd_w-fenst->f_aw));
	else
		fenst->f_slh=0;
	wind_set(fenst->f_hdl,WF_HSLIDE,fenst->f_slh,0,0,0);
	fenst->f_ox-=fenst->f_ax;
	if(fenst->f_oy+fenst->f_ah>fenst->f_vb.mfdbx[0].fd_h)
		fenst->f_oy=fenst->f_vb.mfdbx[0].fd_h-fenst->f_ah;
	if(fenst->f_vb.mfdbx[0].fd_h-fenst->f_ah)
		fenst->f_slv=(int)(((long)fenst->f_oy*1000)/(fenst->f_vb.mfdbx[0].fd_h-fenst->f_ah));
	else
		fenst->f_slv=0;
	wind_set(fenst->f_hdl,WF_VSLIDE,fenst->f_slv,0,0,0);
	fenst->f_oy-=fenst->f_ay;
}


void delete_fenster(FENSTER *fenst)
{	wind_close(fenst->f_hdl);
	wind_delete(fenst->f_hdl);
	entf_fenster(fenst->f_hdl,0);
	fenst->f_hdl=-1;
}
/* Wertet Messages der Standardprotokolle aus:
	AV-Protokoll
	Drag&Drop
*/
int do_msg_prot(int *ev_mgpbuff)
{	int ret=0,id,*msg;
	char **ptr;
	GRECT *gr_redr=NULL;
	FENSTER *fenst;
	switch(ev_mgpbuff[0])
	{	case AV_PROTOKOLL:			/* da will sich jemand anmelden	*/
			ptr=(char **)&ev_mgpbuff[6];
			if(!strcmp("ST-GUIDE",*ptr))
			{	if((Prot_inf.id_stg=appl_find(*ptr))>-1)
					send_va_proto(Prot_inf.id_stg,1);
				ret=-3;
			}
			else
			{	id=appl_find(*ptr);
				send_va_proto(id,0x41);
			}
			break;
		case VA_PROGSTART:
			/* Speicher freigeben,...*/
			break;
		case VA_PROTOSTATUS:	/*AV_PROTOKOLL war erfolgreich	*/
			Prot_inf.id_avserv=ev_mgpbuff[1];	/* der Server	*/
			Prot_inf.av_flag1=ev_mgpbuff[3];	/* Flags		*/
			Prot_inf.av_flag2=ev_mgpbuff[4];	/* und noch mehr Flags		*/
			break;
		case AV_STARTED:	/*VA_START verstanden	*/
			free(&ev_mgpbuff[3]);
			break;
		case AV_SENDKEY:		/* bergabe eines Tastendrucks	*/
			ret=ev_mgpbuff[4];
			break;
		case AV_ACCCWINDOPEN:
			fenst=malloc(sizeof(FENSTER));
			fenst->f_hdl=ev_mgpbuff[3];
			fenst->f_own=ev_mgpbuff[1];
			einf_fenster(fenst);
			break;
		case AV_ACCCWINDCLOSED:
			entf_fenster(ev_mgpbuff[3],1);
			break;
		case AV_EXIT:
			if(ev_mgpbuff[3]==Prot_inf.id_stg)
			{	Prot_inf.id_stg=-1;
				ret=-3;
			}
			if(ev_mgpbuff[3]==Prot_inf.id_avserv)
			{	Prot_inf.id_avserv=-1;
				ret=-3;
			}
			entf_fenster(ev_mgpbuff[3],3);
			break;
			
		case USR_STORED:
			if(ev_mgpbuff[1]==Gem_inf.gm_ahdl)
			{	msg=*((int **)(&ev_mgpbuff[3]));
				appl_write( Gem_inf.gm_ahdl,16,&msg[8*ev_mgpbuff[5]]);
				if((++ev_mgpbuff[5])==ev_mgpbuff[6])
					free(msg);
				else
					appl_write( Gem_inf.gm_ahdl,16,ev_mgpbuff);
			}
			break;
		default:
			ret=ERR_FE_UNBM;
	}
	if(gr_redr)
		redraw(ev_mgpbuff[3],gr_redr,-1);

	return(ret);
}
/* Behandelt Tastendrcke zur Fenstersteuerung, vorher mu getestet werden
ob die Taste fr den Fensterinhalt bestimmt ist
 Rckgabe:
	>0 =ereignis, konte damit nichts anfangen
	=0	erledigt
	-1 	Exitobj	angeklickt*/
int win_keyb(int ereignis,int ums_t)
{	int winmsg_buf[5]={WM_ARROWED,0,0,0,-1},ret=0,is_ob=0;
	if(Gem_inf.gm_tw)
	{	winmsg_buf[3]=Gem_inf.gm_tw->f_hdl;
		if((Gem_inf.gm_tw->f_flags&FE_TYP)==FE_OBJECT)
			is_ob=1;
	}
	else
		winmsg_buf[3]=-1;

	switch(ereignis)
	{	case 0x11B:
			if(is_ob &&	Gem_inf.gm_tw->f_i.fdw.id_ob==FE_PRO)
				Prozent_esc=1;
			break;
		case UNDO:
		case HELP:
			if(is_ob)
			{	Gem_inf.gm_tw->f_i.fdw.nxt_ob=-ereignis;
				ret=-1;
				ereignis=0;
			}
			break;
		case TAB:
			if((ums_t & 3)&&is_ob) /* Shift TAB gedrckt ? */
				ereignis = CUR_UP; /* Umsetzen in Cur_up-Taste */
			break;
		case RETURN:
		case ENTER:
			if(is_ob)
			{	if(!Gem_inf.gm_tw->f_i.fdw.def_ob)
					ereignis=TAB;
			}
			break;
		case CNTRL_W:
			if(Gem_inf.gm_tw)		/* sind berhaupt Fenster offen?*/
			{	Gem_inf.gm_tw=Gem_inf.gm_tw->f_nxt;
				wind_set(Gem_inf.gm_tw->f_hdl,WF_TOP);
			}
			ereignis=0;
			break;
		case CUR_RIGHT:					/* ->	*/
			if(Gem_inf.gm_tw->f_k&HSLIDE &&!is_ob)
			{	winmsg_buf[4]=WA_RTPAGE;
				ereignis=0;
			}
			break;
		case CUR_LEFT:					/* <-	*/
			if(Gem_inf.gm_tw->f_k&HSLIDE &&!is_ob)
			{	winmsg_buf[4]=WA_LFPAGE;
				ereignis=0;
			}
			break;
		case CUR_UP:					/* hoch	*/
			if(Gem_inf.gm_tw->f_k&VSLIDE &&!is_ob)
			{	winmsg_buf[4]=WA_UPPAGE;
				ereignis=0;
			}
			break;
		case CUR_DOWN:					/* runter*/
			if(Gem_inf.gm_tw->f_k&VSLIDE &&!is_ob)
			{	winmsg_buf[4]=WA_DNPAGE;
				ereignis=0;
			}
			break;
	}
	
	if(ereignis)
	{	if( is_ob)
		{	if(!form_keybd(Gem_inf.gm_tw->f_vb.obj, Gem_inf.gm_tw->f_i.fdw.edt_ob, Gem_inf.gm_tw->f_i.fdw.nxt_ob, ereignis, &Gem_inf.gm_tw->f_i.fdw.nxt_ob,&ereignis))
				ret=-1;
			if(ereignis)
				objc_edit(Gem_inf.gm_tw->f_vb.obj, Gem_inf.gm_tw->f_i.fdw.edt_ob, ereignis, &Gem_inf.gm_tw->f_i.fdw.idx, ED_CHAR);
		}
		else
			ret=ereignis;
	}
	if(winmsg_buf[4]>-1)
		do_msg_win(winmsg_buf);
	return(ret);
}

void icon_draw(FENSTER *fenst,GRECT *box)
{	int pxy[8];
	MFDB bs;
	bs.fd_addr=NULL;
	pxy[4]=pxy[0]=box->g_x;
	pxy[5]=pxy[1]=box->g_y;
	pxy[6]=pxy[2]=pxy[0]+box->g_w-1;
	pxy[7]=pxy[3]=pxy[1]+box->g_h-1;
	/*Falls Fenster grer als Bild, Bereich vorher lschen*/
	if(fenst->f_aw>fenst->f_icon->ob_width||fenst->f_ah>fenst->f_icon->ob_height)
		vro_cpyfm(Gem_inf.gm_vhdl,ALL_WHITE,pxy,&bs,&bs);
/*	objc_draw(fenst->f_icon_tr, fenst->f_icon_idx, 1, box->g_x, box->g_y, box->g_w, box->g_h);*/
	objc_draw(fenst->f_icon, 0, 1, box->g_x, box->g_y, box->g_w, box->g_h);
}	
	
void select_rb(OBJECT obj[],int set_nr)
{	int nr,nr_alt;
	obj[set_nr].ob_state |=SELECTED;
	nr=obj[set_nr].ob_next;
	nr_alt=set_nr;
	while(obj[nr].ob_tail!=nr_alt)			/*bis Vater	*/
	{	obj[nr].ob_state &=(~SELECTED);
		nr_alt=nr;
		nr=obj[nr].ob_next;
	}
	nr=obj[nr].ob_head;						/*1. Kind	*/
	while(nr!=set_nr)						/*bis zu setzendes	*/
	{	obj[nr].ob_state &=(~SELECTED);
		nr=obj[nr].ob_next;
	}
}	
int what_rb(OBJECT obj[],int rahmen)
{	int nr,gesetzt=0;
	nr=obj[rahmen].ob_head;					/*1. Kind	*/
	while(nr!=rahmen)						/*alle Kinder*/
	{	if(obj[nr].ob_state &SELECTED)
		{	gesetzt=nr;
			break;
		}
		nr=obj[nr].ob_next;
	}
	return(gesetzt);
}
void einf_fenster(FENSTER *fenster)
{	entf_fenster(fenster->f_hdl,0);
	if(Gem_inf.gm_tw)
	{	fenster->f_nxt=Gem_inf.gm_tw->f_nxt;
		Gem_inf.gm_tw->f_nxt=fenster;
	}
	else
		fenster->f_nxt=fenster;
	Gem_inf.gm_tw=fenster;
}
/* Es wird ein (oder mehrere) Fenster aus der Liste der offenen 
	Fenster (gm_tw)	gelscht. Die folgenden Flags werden beachtet:
	Bit 	0:	1=Speicher (fenster) freigeben
			1:	0=hdl ist das Handel des Fensters
				1=hdl ist die ID des Besitzers
			2:	reserviert
	die Flags in find_fenst und entf_fenster sind identisch, deshalb auch
	Bit 2 reserviert								*/
void entf_fenster(int hdl,int flags)
{	FENSTER *fenster;

	/* zuerst Fenster suchen	*/
	while((fenster=find_fenst(hdl,flags|4))!=NULL)
	{	if(flags&1)
		{	
			free(fenster->f_nxt);
		}
		if(fenster->f_nxt==fenster)	/* war es das letzte?	*/
			Gem_inf.gm_tw=NULL;
		else
			Gem_inf.gm_tw=fenster->f_nxt=fenster->f_nxt->f_nxt;
	}
}
/* macht das angegebene Fenster zum obersten (in der Liste)	 auf. */
void set_top_win(int hdl)
{	FENSTER *fenster;
	if((fenster=find_fenst(hdl,0))!=NULL)
	{
		Gem_inf.gm_tw=fenster;
		if((fenster->f_flags&FE_TYP)==FE_OBJECT && !Gem_inf.gm_tw->f_i.fdw.cur_on)
		{
			objc_edit(Gem_inf.gm_tw->f_vb.obj,Gem_inf.gm_tw->f_i.fdw.edt_ob,  0,&Gem_inf.gm_tw->f_i.fdw.idx,  ED_INIT);
			Gem_inf.gm_tw->f_i.fdw.cur_on=TRUE;
		}
	}
}

/*			 AV-Protokoll				*/
/*
Der grundstzliche Aufbau einer solchen Meldung ist:
    buffer[0] = <Meldungs-Typ>              (z.B. VA_START)
    buffer[1] = <Sender-ID>                 (von appl_init())
    buffer[2] = 0                           ('berlnge')
    buffer[3] = <Kontrolltasten>            (SENDKEY)
                <Fenster-Handle>            (ACCWINDOPEN)
                <Fenster-Handle>            (ACCWINDCLOSED)
                <Fenster-Handle>            (DRAGACCWIND)
                Zeiger auf Pfad (High)      (STARTPROG)
    buffer[4] = <gedrckte Taste>           (SENDKEY)
                Zeiger auf Pfad (Low)       (STARTPROG)
                <Maus-X-Pos.>               (DRAGACCWIND)
                0                           (alle anderen)
    buffer[5] = <Zeiger auf Zeile> (High)   (STARTPROG)
                <Maus-Y-Pos.>               (DRAGACCWIND)
                0                           (alle anderen)
    buffer[6] = <Zeiger auf Zeile> (Low)    (STARTPROG)
                <Zeiger auf Pfad> (High)    (DRAGACCWIND)
                0                           (alle anderen)
    buffer[7] = <Zeiger auf Pfad> (Low)     (DRAGACCWIND)
                0                           (alle anderen)
*/
/* s. ST-Guide Hypertext	*/
/*gibt zurck ob erfolgreich (z_id>0)	
Wenn g_i !=NULL, dann wird gewartet bis das Fenster wieder zu ist*/
int send_va_start(int z_id,char *cmd)
{	int buffer[8]={VA_START,0,0},ret=0;
	char **ptr_cmd;
	
	if(z_id<0)
		form_alert(1,"[0][Hilfe funktioniert|leider nur mit ST-GUIDE][ OK ]");
	else
	{	if(z_id!=Gem_inf.gm_ahdl)
		{	buffer[1]=Gem_inf.gm_ahdl;
			buffer[5]=buffer[6]=buffer[7]=0;
			ptr_cmd=(char **)&buffer[3];
			*ptr_cmd=my_mxalloc(strlen(cmd)+1,MXTTST|MXGLOB);
			strcpy(*ptr_cmd,cmd);
			appl_write(z_id,16,buffer);
			ret=1;
		}
	}
	return(ret);
}


void send_va_proto(int z_id,int flags)
{	int buffer[8]={VA_PROTOSTATUS,0,0};
	char **ptr_cmd;
	if(z_id>-1)
	{	buffer[1]=Gem_inf.gm_ahdl;
		buffer[3]=flags;
		buffer[4]=buffer[5]=0;
		ptr_cmd=(char **)&buffer[6];
		*ptr_cmd=Gem_inf.gm_name;
		appl_write(z_id,16,buffer);
	}
}
/*	Startet Programm ber AV-Server	*/
/* Speicher freigeben	*/
int send_av_stpr(int z_id,char *prg_name,char *cmd,int id)
{	int buffer[8]={AV_STARTPROG,0,0};
	char *prg_name_p,*cmd_p;
	long len;
	if(z_id>-1)
	{	buffer[1]=Gem_inf.gm_ahdl;
		len=strlen(prg_name);
		if((prg_name_p=my_mxalloc(len+strlen(cmd)+2,MXTTST|MXGLOB))==NULL)
			return(ERR_FE_SPEI);
		strcpy(prg_name_p,prg_name);
		cmd_p=&prg_name_p[len+1];
		strcpy(cmd_p,cmd);
		*((char **)&buffer[3])=prg_name_p;
		*((char **)&buffer[5])=cmd_p;
		buffer[7]=id;
		appl_write(z_id,16,buffer);
	}
	return(0);
}
/*	Anmeldung bei AV-Server	*/
void send_av_prot(void)
{	int buffer[8]={AV_PROTOKOLL,0,0};
	if(Prot_inf.id_avserv>-1)
	{	buffer[1]=Gem_inf.gm_ahdl;
		buffer[3]=Prot_inf.av_flag0;
		buffer[4]=buffer[5]=0;
		*((char **)&buffer[6])=Gem_inf.gm_name;
		appl_write(Prot_inf.id_avserv,16,buffer);
	}
}
/*
{	int buffer[8];
	buffer[0]=VA_START;
	buffer[1]=my_id;
	buffer[2]=0;
	buffer[3]=;
	buffer[4]=;
	buffer[5]=;
	buffer[6]=;
	buffer[7]=;
}
get_av(int buffer[])
{	
	switch(buffer[0])
	{	case VA_START:
			
Folgende Meldungen werden erkannt/verwendet:
* VA_START:     (0x4711)
    APP -> ACC: "erwache aus deinem Schlaf und beginne mit der Arbeit";
    ACC -> APP: evtl. AV_ACCWINDOPEN, nachdem das Fenster geff-
    net und die evtl. angegebene Datei geladen wurde. Falls eine
    Kommandozeile angegeben wurde und sich mehr als ein Argument darin
    befindet, so wird alles ab dem ersten Leerzeichen als Name der
    anzuzeigenden Seite interpretiert.

    Laut AV-Doku mssen alle Dateinamen in Grobuchstaben und mit
    vollstndigem Pfad angegeben werden. Um diesem Umstand Rechnung zu
    tragen und trotzdem zuzulassen, da die aufrufende Applikation nicht
    wei, wo sich der Hypertext befindet, wurde als Spezialfall das
    'Laufwerk' "*" implementiert: Angabe von "*:\AES.HYP" veranlat den
    ST-Guide, die Datei AES.HYP auf allen angegebenen Pfaden zu suchen.

    Aufruf mit 'C:\AES.HYP appl_init' wrde also AES.HYP laden und daraus
    die Seite <appl_init> anzeigen.

    Aufruf mit 'C:\AES.REF appl_init' wrde den Begriff <appl_init> in der
    Datei AES.REF suchen und im Erfolgsfall die Datei AES.HYP laden und daraus
    die Seite anzeigen, in der das gesuchte Symbol definiert wurde.

    Aufruf mit 'C:\AES.HYP' wrde die angegebene Datei laden und die erste
    Seite aus ihr darstellen.

    Aufruf mit 'appl_init' wrde diesen Begriff in der durch 'REF'
    angegebenen Datei suchen und die passende Seite aus der betreffenden
    Datei darstellen

* VA_DRAGACCWIND:   (0x4725)
    APP -> ACC: "es wurde eine Datei auf eines deiner Fenster gezogen,
    hier hast du den Pfad"; der Guide ldt daraufhin die so angegebene
    Datei und zeigt sie im Fenster an. Auch hier mu der vollstndige
    Zugriffspfad angegeben werden.

* AV_SENDKEY:       (0x4710)
    ACC -> APP: "es wurde eine Taste gedrckt, mit der ich nichts anfangen
    kann, hier hast du sie"; hierdurch wird die Benutzung aller
    Shortcuts der Applikation ermglicht, auch wenn das ACC Besitzer des
    obersten Fensters ist.

* AV_STARTPROG:     (0x4723)
    ACC -> APP: "starte mal das in dieser Meldung angegebene Programm mit
    der ebenfalls evtl. angegebenen Kommandozeile"; Der Guide benutzt
    diese Meldung fr die Ausfhrung von SYSTEM Anweisungen. Thing und
    GEMINI untersttzen hier auch die Angabe von nicht ausfhrbaren
    Dateien, fr deren Endung dann ein Programm gesucht und gestartet
    wird.

    APP -> ACC: VA_PROGSTART, wird vom Guide jedoch ignoriert.

* AV_ACCWINDOPEN:   (0x4724)
    ACC -> APP: "ich habe gerade ein Fenster geffnet"; da das Handle
    dieses Fensters mitgeliefert wird, dient es u.a. dem Zweck, das
    Window-Cycling der Hauptapplikation auf die Fenster der ACC's
    auszuweiten oder dem ACC zu melden, wenn Objekte auf eines seiner
    Fenster gezogen wurden (siehe VA_DRAGACCWIND);

* AV_ACCWINDCLOSED: (0x4726)
    ACC -> APP: "ich habe gerade eines meiner Fenster geschlossen";
    Gegenstck zu ACCWINDOPEN.

* AV_EXIT:
    ACC -> APP: "ich melde mich ab - und Tsch"

*AV_PROTOKOLL:
    ACC -> APP: "hier bin ich"
*/



/* Dialoge in Fenstern verwalten, nach ST-Computer 5/93 S.90ff	*/
/************************************************/
/* 												*/
/* Unit ...............: UTILAES 				*/
/* Inhalt .............: Ntzliche Prozeduren 	*/
/* und Funktionen im Umgang mit dem AES und 	*/
/* Dialogen 									*/
/* Funktionen .........: siehe Beschreibung im	*/
/* Headerfile 									*/
/* Erstellt ...........: 22/06/92 				*/
/* Entwickler .........: Thomas Krieger 		*/
/* Version ............: 1.20 					*/
/* C-Version von.......: Dimitri Junker			*/
/*			 vom.......: 14/10/95				*/
/* 												*/
/************************************************/




void do_redraw(OBJECT *tree,int fenster,int x,int y,int w,int h)
{	GRECT r1, r2;

 /* Koordinaten des Bildschirmbereichs in die
 Rechtechstruktur r1 eintragen */

	r1.g_x = x;
	r1.g_y = y;
	r1.g_w = w;
	r1.g_h = h;

 /* Bildschirm fr andere Applikationen fr 
 die Dauer des Updates sperren und Maus
 ausschalten */
 
	wind_update(BEG_UPDATE);
	graf_mouse(M_OFF, NULL);

 /* Erstes Rechteck aus der Rechteckliste holen */
 
	wind_get(fenster, WF_FIRSTXYWH, &r2.g_x, &r2.g_y, &r2.g_w, &r2.g_h);
 
	while(r2.g_w && r2.g_h) /* Solange nicht leer */
 	{	 if(rc_intersect(&r1, &r2)) /* berlappungsbereich ermitteln */
 
		 {
 /* Dialogbox im berlappungsbereich neu zeichnen. Dieser Bereich 
 befindet sich in der Rechteckstruktur  r2 */

			objc_draw(tree, 0, 8, r2.g_x, r2.g_y, r2.g_w, r2.g_h);
		 }

 /* Nchstes Rechteck aus der Rechteckliste holen */
 
		 wind_get(fenster, WF_NEXTXYWH, &r2.g_x, &r2.g_y, &r2.g_w, &r2.g_h);
	}

 /* Das war's; Maus an, Bildschirm wieder freigeben */
 
	graf_mouse(M_ON, NULL);
	wind_update(END_UPDATE);
}

void do_move_4obj(FENSTER *fenst, int x, int y)
{	int wx, wy, ww, wh,pipe[8],screen_max_X, screen_max_Y, dummy;
	OBJECT *tree;
	 if((fenst->f_flags&FE_OBJECT)==0)
	 	return;
/* Offset zurcksetzen (^Fenster ab 0,0)	*/
	if((fenst->f_flags&FE_ICONIF)==0)
	{	fenst->f_ox+=fenst->f_ax;
		fenst->f_oy+=fenst->f_ay;
	}
 /* Lage des Fensters ermitteln */

	wind_get(fenst->f_hdl, WF_CURRXYWH, &wx, &wy, &ww, &wh);

 /* Maximale Bildschirmbreite und Bildschirmhhe ermitteln*/

	wind_get(0,WF_WORKXYWH, &dummy, &dummy, &screen_max_X, &screen_max_Y);

 /* Fenster soll nicht ber den Bildschirmrand hinaus ragen */

	if(((x + ww) > screen_max_X))
		x = screen_max_X - ww;
 
	if( ((y + wh) > screen_max_Y))
		 y = screen_max_Y - wh;

 /* Neue Fensterkoordinaten setzen und daraus den neuen Arbeitsbereich ermitteln */
 
	wind_set(fenst->f_hdl, WF_CURRXYWH, x, y, ww, wh);
	wind_get(fenst->f_hdl, WF_WORKXYWH, &fenst->f_ax, &fenst->f_ay, &fenst->f_aw, &fenst->f_ah);

 /* Eintragen der Koordinaten in die Objekt- Struktur */
	if(fenst->f_flags&FE_ICONIF)
	{	tree=fenst->f_icon;
		tree->ob_x = fenst->f_ax + (fenst->f_aw-tree->ob_width)/2;
		tree->ob_y = fenst->f_ay + (fenst->f_aw-tree->ob_width)/2;
	}
	else
	{	tree=fenst->f_vb.obj;
		tree->ob_x = fenst->f_ax ;
		tree->ob_y = fenst->f_ay ;
/* Offset wieder setzen 	*/
		fenst->f_ox-=fenst->f_ax;
		fenst->f_oy-=fenst->f_ay;
	}

 /* WM_REDRAW-Meldung generieren und abschicken */
 
	pipe[0] = WM_REDRAW;
	pipe[3] = fenst->f_hdl;
	pipe[4] = x;
	pipe[5] = y;
	pipe[6] = ww;
	pipe[7] = wh;
 
	appl_write(Gem_inf.gm_ahdl, (int)sizeof(pipe), pipe);
}

int find_object(OBJECT *tree,int start_object,int which)
{	int ret, object=0, flag= EDITABLE, theflag, increment=1;
 	switch(which)
 	{	case FMD_BACKWARD:
			increment= -1;
		case FMD_FORWARD:
			object = start_object + increment;
			break;
		case FMD_DEFLT:
			 flag = DEFAULT;
	}

	ret = start_object;
 
	while(object >= 0)
	{	theflag = tree[object].ob_flags;
		if( (theflag & flag) > 0)
		{
			ret = object;
 			break;
 		}
		if( (theflag & LASTOB) > 0)
			object = -1;
		else
			object += increment;
	}
 
	return(ret);
}

int ini_field(OBJECT *tree,int start_field)
{
	if(!start_field)
		start_field = find_object(tree, 0, FMD_FORWARD);
	return(start_field);
}

void fdw_ini(int fenster,int start_field)
{	FENSTER *win;
	win=find_fenst(fenster,0);
	win->f_i.fdw.nxt_ob= ini_field(win->f_vb.obj, start_field);
	win->f_i.fdw.def_ob = find_object(win->f_vb.obj, 0, FMD_DEFLT);
	if( win->f_i.fdw.nxt_ob)
	{	win->f_i.fdw.edt_ob= win->f_i.fdw.nxt_ob;
		win->f_i.fdw.nxt_ob= 0;
		objc_edit(win->f_vb.obj, win->f_i.fdw.edt_ob,0, &win->f_i.fdw.idx, ED_INIT);
		win->f_i.fdw.cur_on=TRUE;
	}
	else
	{
		win->f_i.fdw.edt_ob= 0;
		win->f_i.fdw.cur_on=FALSE;
	}
}
/* Behandelt Events soweit wie sie sich auf Formulare beziehen.
	Ausgewertet werden MU_MESAG,MU_KEYBD und MU_BUTTON
Param.:	which:	z.B. Rckgabe von evnt_multi
		msg:	Messagebuffer, siehe evnt_mesag und ev_mgpbuff
		kr:		der Scancode der gedrckten Taste
		ks:		den Zustand der Sondertasten der Tastatur
		mx,my:	die x und y Koordinate des Mauszeigers
		br:		Anzahl der Klicks mit der Maustaste		*/
FENSTER *fdw_do(int *which,int *msg,int kr,int ks,int mx,int my,int br)
{	int cont=1;
	OBJECT *obj=NULL;
	FDWI *fdw=NULL;
	FENSTER *win=NULL;
/* falls kein bekanntes Fenster offen oder kein zu behandelndes Ereignis
	eingetreten, dann zurck	*/
	if(!Gem_inf.gm_tw || (*which&(MU_MESAG|MU_KEYBD|MU_BUTTON))==0)
		return(NULL);
	if( (*which & MU_MESAG) > 0)
	{	if((win=find_fenst(msg[3],0))!=NULL)
		{	if((win->f_flags&FE_TYP)==FE_OBJECT)	/* Msg fr Object	*/
			{	if((kr=do_msg_win(msg))==0)
				{	if((kr=do_msg_prot(msg))>0)		/* Tastendruck per AV?*/
					{	if(win_keyb(kr,ks)==-1)
							cont=0;
					}
				}
				obj=win->f_vb.obj;
				fdw=&win->f_i.fdw;
				if(kr>-1)
					*which&=(~MU_MESAG);		/*erledigt	*/
			}
		}
	}
	if( (*which & MU_KEYBD) > 0)
	{	if((win=find_fenst(Gem_inf.gm_tw->f_hdl,0))!=NULL)
		{	if((win->f_flags&FE_TYP)==FE_OBJECT)	/* ist Object	*/
			{	obj=win->f_vb.obj;
				fdw=&win->f_i.fdw;
			}
		}

		switch(win_keyb(kr,ks))
		{	case -1:					/* Exit Opjekt & erledigt	*/
				cont=0;
			case 0:
				*which&=(~MU_KEYBD);	/*erledigt	*/
				break;
		}
		win=Gem_inf.gm_tw;
	}
	if( (*which & MU_BUTTON) > 0)
	{	if((win=find_fenst(wind_find(mx, my),0))!=NULL)
		{	if((win->f_flags&FE_TYP)==FE_OBJECT)	/* Maus auf Object	*/
			{	obj=win->f_vb.obj;
				fdw=&win->f_i.fdw;
				fdw->sel_ob= objc_find(obj, 0, 8, mx, my);
				if( (fdw->sel_ob == -1))
					fdw->sel_ob = 0;
				else
					cont = form_button(obj,  fdw->sel_ob, br, &fdw->nxt_ob);
				*which&=(~MU_BUTTON);	/*erledigt	*/
			}
		}
	}
	if(obj)
	{	
		if( (!cont || fdw->nxt_ob) && (fdw->nxt_ob != fdw->edt_ob)&& fdw->edt_ob)
		{	
			if(fdw->cur_on)
				objc_edit(obj,fdw->edt_ob,0,&fdw->idx, ED_END);
			if(cont)
			{	fdw->edt_ob= fdw->nxt_ob;
				fdw->nxt_ob= 0;
				objc_edit(obj, fdw->edt_ob,0, &fdw->idx, ED_INIT);
				fdw->cur_on=TRUE;
			}
			else
			{
				fdw->nxt_ob=0;
				fdw->cur_on=FALSE;
			}
		}
	}
	if(cont)
		return(NULL);
	else
		return(win);
}



/*	titel:	max 30 char z.B. File laden	-> Initaufruf
			NULL		Zwischenaufruf
	anteil:	Der bereits erfolgte Teil.
			Bei Init der maximale (^100%)
			-1:	Schlieen
	do_evnt:0: wird aus normaler Eventauswertung ausgerufen ->
					nur Prozent_esc auswerten
			1: wird nicht aus normaler Eventauswertung ausgerufen ->
				eigenes evnt_multi verwenden
	Rckgabe: ERR_FE_ABB:	Abbruch
			  0				weiter
*/
	

/* but: Button oder -1: Aufbau mit Speichern-Button
					-2:	Aufbau ohne Speichern-Button
					-1 oder -2 kommen in einem Programm nie beide vor, deshalb
						kann es wie unten vereinfacht werden
	Rckgabe: -1:			weiter
			  -2:			help
			  0: 			OK	(ID richtig)
			  1: 			speichern	(ID richtig)
			  2:			Abbruch
*/
#pragma warn +par
int fenst_4_obj(OBJECT *ob_drtree,char *fenstertitel,int id)
{	FENSTER *obj_win;
	int x,y,w,h;
	/* Ermitteln der Koordinaten der Dialogbox
         aus der Objektstruktur */
	if(ob_drtree->ob_state&ACTIVE)
		return(-1);
	ob_drtree->ob_state|=ACTIVE;
	x= ob_drtree->ob_x;
	y= ob_drtree->ob_y;
	w= ob_drtree->ob_width;
	h= ob_drtree->ob_height;
	/* FENSTER ausfllen	*/
	obj_win=calloc(1,sizeof(FENSTER));
	
 /* Berechnen des Begrenzugsrechtecks */
	wind_calc(WC_BORDER, NAME + MOVER, x, y, w, h, 
		&obj_win->f_ax, &obj_win->f_ay, &obj_win->f_aw, &obj_win->f_ah);
 
 /* Besorgen des Fenster-Handles */
	obj_win->f_k=NAME | MOVER;	
	if((obj_win->f_hdl = wind_create(obj_win->f_k, obj_win->f_ax, obj_win->f_ay, obj_win->f_aw, obj_win->f_ah))>0)
	{	obj_win->f_own=Gem_inf.gm_ahdl;
    /* Bildschirmausschnitt reservieren  und wachsendes rechteck zeichnen */

		form_dial(FMD_START,0,0,0,0,x,y,w,h);
		form_dial(FMD_GROW,0,0,0,0,x,y,w,h);

    /* Fenstername eintragen */
    
		wind_set(obj_win->f_hdl,WF_NAME,fenstertitel,0, 0);

    /* Fenster ffnen  */
    
		wind_open(obj_win->f_hdl, obj_win->f_ax, obj_win->f_ay, obj_win->f_aw, obj_win->f_ah);
	/* obj eintragen	*/
		obj_win->f_flags=FE_OBJECT;
		obj_win->f_vb.obj=ob_drtree;
		einf_fenster(obj_win);
	}
	obj_win->f_i.fdw.id_ob=id;
	obj_win->f_i.fdw.drw_ob=0;		/* Normalerweise alles zeichnen	*/
	return(obj_win->f_hdl);
}
void del_fenst_4_obj(int ob_win)
{	FENSTER *win;
	if((win=find_fenst(ob_win,0))!=NULL)
	{	win->f_vb.obj->ob_state&=~ACTIVE;
		entf_fenster(ob_win,1);
		wind_close(ob_win);
		wind_delete(ob_win);
	}
}
/* es wird das erste Fenster gesucht, da die Bedingung (Handel oder
	ID des Besitzers) erfllt. Die folgenden Flags werden beachtet:
	Bit 	0:	reserviert
			1:	0=hdl ist das Handel des Fensters
				1=hdl ist die ID des Besitzers
			2:	1=Vorgnger zurck geben			
	die Flags in find_fenst und entf_fenster sind identisch, deshalb auch
	Bit 0 reserviert
	
	Rckgabe: Fenster oder NULL								*/
FENSTER *find_fenst(int hdl,int flags)
{	FENSTER *fenster;
	int hdl2;
	if(Gem_inf.gm_tw==NULL)
		return(NULL);
	fenster=Gem_inf.gm_tw;
	if(flags&2)
	{	while(fenster->f_nxt->f_own!=hdl && fenster->f_nxt!=Gem_inf.gm_tw)
			fenster=fenster->f_nxt;
		hdl2=fenster->f_nxt->f_own;
	}
	else
	{	while(fenster->f_nxt->f_hdl!=hdl && fenster->f_nxt!=Gem_inf.gm_tw)
			fenster=fenster->f_nxt;
		hdl2=fenster->f_nxt->f_hdl;
	}
	if(hdl2!=hdl)						/* erfolgreich?			*/
		fenster=NULL;
	else
	{	if(!(flags&4))
			fenster=fenster->f_nxt;
	}
	return(fenster);
}
/* Ausschnitt "area" in Fenster "wh" neuzeichnen. Basiert auf
	Beispielfunktion aus "Professional GEM" (Tim Oren)	
	wenn area==NULL: ganzes fenst neu zeichnen*/
	/*neu: start: fr Formularfenster: die Nummer des Startobjektes, im Zweifelsfall -1*/
void redraw(int wh,GRECT *area,int start)
{	GRECT box,full;
	int r_ok;
	BOOL swichCurOn=FALSE;
	FENSTER *fenst;
	if((fenst=find_fenst(wh,0))==NULL)
		return;					/* Fenster nicht offen	*/
	if(fenst->f_own!=Gem_inf.gm_ahdl)
		return;					/* fremdes Fenster	*/
	wind_update(BEG_UPDATE);
	graf_mouse(M_OFF,NULL);			/* Maus auschalten			*/



	if((fenst->f_flags&FE_TYP)==FE_OBJECT && fenst->f_i.fdw.edt_ob>0 && fenst->f_i.fdw.cur_on)
	{
		objc_edit(fenst->f_vb.obj,fenst->f_i.fdw.edt_ob,  0,&Gem_inf.gm_tw->f_i.fdw.idx,  ED_END);
		fenst->f_i.fdw.cur_on=FALSE;
		swichCurOn=TRUE;
	}
	Vsync();
	
	/* Arbeitsbereich von Fenster Null abfragen	*/
	wind_get (0,WF_CURRXYWH,&full.g_x,&full.g_y,&full.g_w,&full.g_h);
	if(area)
		r_ok=rc_intersect(area,&full);
	else
		r_ok=rc_intersect((GRECT *)fenst,&full);
	/*erstes Element der Rechteckliste erfragen	*/
	if(r_ok)	
		r_ok=wind_get (wh,WF_FIRSTXYWH,&box.g_x,&box.g_y,&box.g_w,&box.g_h);
		
	/* solange gltiges Rechteck (Breite und Hhe ungleich Null)	*/
	while(r_ok && box.g_w && box.g_h)
	{	if(rc_intersect (&full,&box))		/*berlappung?	*/
		{	switch(fenst->f_flags&FE_TYP)
			{	case FE_OBJECT:	/* Formular Fenster	*/
					if(start<0)
						start=fenst->f_i.fdw.drw_ob;
					objc_draw(fenst->f_vb.obj, start, 8, box.g_x, box.g_y, box.g_w, box.g_h);
				case FE_ICONIF: /* iconifiziert aber ohne ICON. Sollte nicht vorkommen*/
					break;
				case FE_OBJECT|FE_ICONIF:	/* iconifiziert mit ICON*/
					icon_draw(fenst,&box);
			}
		}
		/* nchstes Element der Rechteckliste erfragen */
		r_ok=wind_get (wh,WF_NEXTXYWH,&box.g_x,&box.g_y,&box.g_w,&box.g_h);
	}
	wind_update(END_UPDATE);
	graf_mouse(M_ON,NULL);
	if(swichCurOn && fenst->f_i.fdw.edt_ob)
	{
		objc_edit(fenst->f_vb.obj,fenst->f_i.fdw.edt_ob,  0,&Gem_inf.gm_tw->f_i.fdw.idx,  ED_INIT);
		fenst->f_i.fdw.cur_on=TRUE;
	}
}
/* Fhrt MSGs fr Windows aus
	Rckgabe: 0 : 	alles OK
			 -3	:	ST-Guide hat sich an oder abgemeldet
			 <-200: Fehler bzw AP_TERM
			 >0	:	Tastendruck			*/
int do_msg_win(int *ev_mgpbuff)
{	int ret=0;
	GRECT *gr_redr=NULL;
	FENSTER *fenst;
	if((fenst=Gem_inf.gm_tw)==NULL)
		return(ERR_FE_UNBF);				/* kein mir bekanntes Fenster offen	*/
								/* Fenster suchen					*/
	while(fenst->f_hdl!=ev_mgpbuff[3] && fenst->f_nxt!=Gem_inf.gm_tw)
		fenst=fenst->f_nxt;
	if(ev_mgpbuff[3]!=fenst->f_hdl || fenst->f_own!=Gem_inf.gm_ahdl)
		return(ERR_FE_UNBF);		/* Fenster unbekannt oder fremder Eigentmer	*/

	switch(ev_mgpbuff[0])
	{	case WM_ARROWED:
			if(ev_mgpbuff[4]<4)
			{	fenst->f_slv=max(0,min(1000,fenst->f_slv+fenst->f_sldv[ev_mgpbuff[4]]));
				wind_set(fenst->f_hdl,WF_VSLIDE,fenst->f_slv,0,0,0);
				fenst->f_oy=-fenst->f_ay+
					d_satz(fenst->f_slv,1000,max(0,fenst->f_vb.mfdbx[0].fd_h-fenst->f_ah));
			}
			else
			{	fenst->f_slh=max(0,min(1000,fenst->f_slh+fenst->f_sldh[ev_mgpbuff[4]]));
				wind_set(fenst->f_hdl,WF_HSLIDE,fenst->f_slh,0,0,0);
				fenst->f_ox=-fenst->f_ax+
					d_satz(fenst->f_slh,1000,max(0,fenst->f_vb.mfdbx[0].fd_w-fenst->f_aw));
			}
			gr_redr=(GRECT *)fenst;
			break;
		case WM_HSLID:
			fenst->f_slh=ev_mgpbuff[4];
			wind_set(fenst->f_hdl,WF_HSLIDE,fenst->f_slh,0,0,0);
			fenst->f_ox=-fenst->f_ax+
				d_satz(fenst->f_slh,1000,max(0,fenst->f_vb.mfdbx[0].fd_w-fenst->f_aw));
			gr_redr=(GRECT *)fenst;
			break;
		case WM_VSLID:
			fenst->f_slv=ev_mgpbuff[4];
			wind_set(fenst->f_hdl,WF_VSLIDE,fenst->f_slv,0,0,0);
			fenst->f_oy=-fenst->f_ay+
				d_satz(fenst->f_slv,1000,max(0,fenst->f_vb.mfdbx[0].fd_h-fenst->f_ah));
			gr_redr=(GRECT *)fenst;
			break;
		case WM_SIZED:
			wind_sized((GRECT *)&ev_mgpbuff[4],fenst);
			fenst->f_flags&=(~FE_ISFULL);
			break;
		case WM_FULLED:
			wind_get(fenst->f_hdl,WF_CURRXYWH,&ev_mgpbuff[4],&ev_mgpbuff[5],&ev_mgpbuff[6],&ev_mgpbuff[7]);
			if(fenst->f_flags&FE_ISFULL)
				wind_get(fenst->f_hdl,WF_PREVXYWH,&ev_mgpbuff[4],&ev_mgpbuff[5],&ev_mgpbuff[6],&ev_mgpbuff[7]);
			else
				wind_get(fenst->f_hdl,WF_FULLXYWH,&ev_mgpbuff[4],&ev_mgpbuff[5],&ev_mgpbuff[6],&ev_mgpbuff[7]);
		 	wind_sized((GRECT *)&ev_mgpbuff[4],fenst);
		 	fenst->f_flags^=FE_ISFULL;
			wind_get(ev_mgpbuff[3],WF_WORKXYWH,&fenst->f_ax,&fenst->f_ay,&fenst->f_aw,&fenst->f_ah);
			fenst->f_ox=-fenst->f_ax;
			fenst->f_oy=-fenst->f_ay;
			break;
		case WM_MOVED:
			if((fenst=find_fenst(ev_mgpbuff[3],0))!=NULL)
			{	switch(fenst->f_flags&FE_TYP)
				{	case FE_OBJECT:	/* Formular Fenster	*/
					case FE_OBJECT|FE_ICONIF:	/* iconifiziert mit ICON*/
						do_move_4obj(fenst, ev_mgpbuff[4], ev_mgpbuff[5]);
					case FE_ICONIF: /* iconifiziert aber ohne ICON. Sollte nicht vorkommen*/
						break;
				}
			}
			break;
		case WM_UNTOPPED:
			if((fenst=find_fenst(ev_mgpbuff[3],0))!=NULL)
			{
				if((fenst->f_flags&FE_TYP)==FE_OBJECT && fenst->f_i.fdw.cur_on)
				{
					objc_edit(fenst->f_vb.obj,fenst->f_i.fdw.edt_ob,0,&fenst->f_i.fdw.idx,ED_END);
					fenst->f_i.fdw.cur_on=FALSE;
				}
			}
			break;
		case WM_REDRAW:
			gr_redr=(GRECT *)&ev_mgpbuff[4];
			break;
		case WM_CLOSED:
			delete_fenster(fenst);
			break;
		case WM_TOPPED:
			wind_set(ev_mgpbuff[3],WF_TOP);
		case WM_ISTOP:
		case WM_ONTOP:
		case WM_NEWTOP:
			set_top_win(ev_mgpbuff[3]);
			break;
		case WM_BOTTOMED:
			wind_set (ev_mgpbuff[3],WF_BOTTOM, 0, 0 ,0, 0);
			break;
		default:
			ret=ERR_FE_UNBM;
	}
	if(gr_redr)
		redraw(ev_mgpbuff[3],gr_redr,-1);

	return(ret);
}

int fehler_fe(char *meldung,int fehler)
{	int rueck;
	switch(fehler)
	{
			case ERR_FE_STD:			/*Falscher fd_stand			*/
				strcpy(meldung,"[1][Interner Fehler");
				rueck=0;
				break;
			case ERR_FE_UTC:
				strcpy(meldung,"[1][Seltsames True Color Format.|Bitte File TC_Palet.txt an|mich schicken und in anderer|Auflsung booten");
				rueck=1;
				break;
			case ERR_FE_UNBF:
				strcpy(meldung,"[1][Mir unbekanntes Fenster");
				rueck=-1;
				break;
			case ERR_FE_UNBM:
				strcpy(meldung,"[1][Mir unbekannte Mesage");
				rueck=0;
				
	#ifdef debug
				rueck=-1;
	#endif
				break;
			case ERR_FE_CFG:		/* Fehler im CFG-File	*/
				strcpy(meldung,"[1][Fehler im Drucker CFG File");	
				rueck=0;
				break;
			case ERR_FE_INIT:			/*Fehler bei INIT		*/
				strcpy(meldung,"[1][Initialisierung erfolglos");
				rueck=1;
				break;
				
			case ERR_FE_TERM:
				rueck=1;
				break;
		default:
			strcpy(meldung,"[1][unbekannter Fehler");	
			rueck=0;
			break;
	}
	return(rueck);
}
/*** ------------------------------------------------------------------------ ***/
/*	void setLog2Def(char *lPfad,size_t len)										*/
/*	Bildet einen Standardpfad fr das LOG-File									*/
/*	Parameter:	lPfad,size_t len												*/
/*	Ergebnis:	keines															*/		
/*** ------------------------------------------------------------------------ ***/
void mkLogName(char *lPfad,size_t len) 
{
	char *ptrTmp;
	ptrTmp=getenv("LOGDIR");
	if(!ptrTmp)
		ptrTmp=getenv("TMPDIR");
	if(!ptrTmp)
		ptrTmp=".";
	strncpy(lPfad,ptrTmp,len);
	ptrTmp=strrchr(lPfad,'\\');
	if(!ptrTmp || ptrTmp[1])
		strncat(lPfad,"\\",len);
	strncat(lPfad,Gem_inf.gm_name,len);
	ptrTmp=strchr(lPfad,'\0');
	while(*(--ptrTmp)==' ')
		*ptrTmp='\0';
	strncat(lPfad,".log",len);
}
int d_satz(int alt,int alt_max,int neu_max)
{	int neu;
	neu=(int)((double)alt/(double)alt_max*(double)neu_max+.5);
	if(neu<0) neu=0;
	if(neu>neu_max) neu=neu_max;
	return(neu);
}

/*
	Aus TOS.HYP
   Mxmask() liefert eine Bitmaske mit der man das Moduswort eines
   Mxalloc() Aufrufs maskieren sollte, falls man Protectionbits
   benutzen mchte. Dies ist notwendig, da Mxalloc() bei der Angabe
   von Protectionbits leider in einigen GEMDOS Implementierungen
   fehlerhafte Resultate liefert, die in der Folge zum Absturz des
   Systems fuehren koennen. ((c) 1994 Martin Osieka)
   Anwendungsbeispiel:
   mxMask = Mxmask();
   p = mxMask ? Mxalloc( size, 0x43 & mxMask) : Malloc( size); */

int Mxmask (VOID)
{
    VOID *svStack;      /* Supervisorstack */
    LONG sRAM, sRAMg;   /* ST-RAM          */
    LONG aRAM, aRAMg;   /* Alternate RAM   */
 
    /*
    // Beispieltabelle moeglicher Werte:
    //           | newfashion  | oldfashion
    // sRAM aRAM | sRAMg aRAMg | sRAMg aRAMg
    //   1    0  |   1     0   |   1     1
    //   0    2  |   0     2   |   2     2
    //   1    2  |   1     2   |   3     3
    */

    svStack = (VOID *) Super( 0);  /* unterbinde Taskwechsel */
 
    sRAM  = (LONG) Mxalloc( -1, 0);
    sRAMg = (LONG) Mxalloc( -1, 0x40); /* im Fehlerfall Mxalloc( -1, 3) */
    aRAM  = (LONG) Mxalloc( -1, 1);
    aRAMg = (LONG) Mxalloc( -1, 0x41); /* im Fehlerfall Mxalloc( -1, 3) */
 
    Super( svStack);  /* erlaube Taskwechsel */

    if (sRAM == -32)
        return 0x0000;  /* Mxalloc() ist nicht implementiert */
 
    else if ( ((sRAM + aRAM) == sRAMg) && ((sRAM + aRAM) == aRAMg) )
        return 0x0003;  /* oldfashion Mxalloc() */
 
    else
        return 0xFFFF;
 
} /* Mxmask */

void *my_mxalloc(size_t laenge,int mode)
{
	void *ret=NULL;
	static int first=1, mx_mask=0;
	if(first)
		mx_mask=Mxmask();

	if(!laenge)
		return(NULL);
	if(!mx_mask)
		return(malloc(laenge));
	ret=Mxalloc(laenge,mode&mx_mask);


/* das war's	*/
#ifdef debug
	if(!ret)
	{
		char fehler[90];
		sprintf(fehler,"[1][kein Speicher fr Mode:%i|Mxalloc][Schaade]",mode);
		form_alert(1,fehler);
	}
#endif
	return(ret);
}

#pragma warn -par
int meld_def(char *meldung,int fehler)
{	strcpy(meldung,"[1][unbekannter Fehler");
	return(0);
}
#pragma warn +par
void set_errm(int bibl,int (meldungen)(char *,int))
{
	bibl*=-1;
	bibl>>=8;
	Meldungen[bibl]=meldungen;
}


