// TimeOutSocket.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "in2cat.h"
#include "TimeOutSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimeOutSocket

CTimeOutSocket::CTimeOutSocket()
{
	m_tEndzeit=0;
}

CTimeOutSocket::~CTimeOutSocket()
{
}


//Die folgenden Zeilen nicht bearbeiten. Sie werden vom Klassen-Assistenten bentigt.
#if 0
BEGIN_MESSAGE_MAP(CTimeOutSocket, CSocket)
	//{{AFX_MSG_MAP(CTimeOutSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// Member-Funktion CTimeOutSocket 

BOOL CTimeOutSocket::SetTimeOut(UINT uTimeOut)
{
     m_nTimerID = SetTimer(NULL,0,uTimeOut,NULL);
	 m_tEndzeit=time(NULL)+uTimeOut/1000+1;

	 TRACE("SetTimeOut:uTimeOut:%d, m_nTimerID:%x; Endzeit:%d\n",uTimeOut,m_nTimerID,m_tEndzeit);
     return m_nTimerID;

}

BOOL CTimeOutSocket::KillTimeOut()
{
	 m_tEndzeit=0;
     return KillTimer(NULL,m_nTimerID);
}

BOOL CTimeOutSocket::OnMessagePending() 
{
     MSG msg;
     if(::PeekMessage(&msg, NULL, WM_TIMER, WM_TIMER, PM_NOREMOVE))
     {
       if (msg.wParam == (UINT) m_nTimerID ||(m_tEndzeit && m_tEndzeit<time(NULL)))
       {
         // Remove the message and call CancelBlockingCall.
         ::PeekMessage(&msg, NULL, WM_TIMER, WM_TIMER, PM_REMOVE);
         CancelBlockingCall();
		 m_tEndzeit=0;
         return FALSE;  // No need for idle time processing.
       }
    };

     return CSocket::OnMessagePending();
}
