// ESELINCONN.cpp: Implementierungsdatei
//
//		Version 2,x
//		(c) 2003 by Dimitri Junker
//			Adenauerallee 30
//			52066 Aachen	
//		Dieses File ist Teil des In2Cat-Projektes und steht unter der
//		In2Cat Public License. Dementspechend ist es Freeware und darf
//		entsprechend der o.g. Liscense weitergegeben und verndert werden.
//		Eine Kopie der In2Cat Public License liegt diesem Paket bei
//		Diese Copyright Meldung darf nur vom Copyright Inhaber gendert werden.
//

#include "stdafx.h"
#include "in2cat.h"
#include "ESELINCONN.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include <ras.h>
#include <raserror.h>
/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CESELINCONN 


CESELINCONN::CESELINCONN(CWnd* pParent /*=NULL*/)
	: CDialog(CESELINCONN::IDD, pParent)
{
	//{{AFX_DATA_INIT(CESELINCONN)
	m_conn = _T("");
	//}}AFX_DATA_INIT
}


void CESELINCONN::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CESELINCONN)
	DDX_LBString(pDX, IDC_CONN, m_conn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CESELINCONN, CDialog)
	//{{AFX_MSG_MAP(CESELINCONN)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CESELINCONN 

BOOL CESELINCONN::OnInitDialog() 
{
	CListBox* pLB =(CListBox*) GetDlgItem(IDC_CONN);
   LPRASENTRYNAME lpRasEntry;
    LPRASENTRYNAME lpTemp;
    DWORD cbBuf;
    DWORD cEntry;
    DWORD dwRet;
    UINT  ndx;
    char  szMessage[256];

    cbBuf = sizeof(RASENTRYNAME);
    if ((lpRasEntry = ( LPRASENTRYNAME ) malloc((UINT)cbBuf)) != NULL ) 
    {
        lpRasEntry->dwSize = sizeof(RASENTRYNAME);
        dwRet = RasEnumEntries( NULL, NULL, lpRasEntry, &cbBuf, &cEntry );
        if ( dwRet == ERROR_BUFFER_TOO_SMALL )
        {
            if ((lpTemp = ( LPRASENTRYNAME ) realloc ( lpRasEntry, (UINT)cbBuf )) != NULL )
            {
                lpRasEntry = lpTemp;
                dwRet = RasEnumEntries( NULL, NULL, lpRasEntry, &cbBuf, &cEntry );
            }
            else
            {
                dwRet = ERROR_NOT_ENOUGH_MEMORY;
            }
        }
        else if ( dwRet != 0 ) // other error
        {
            if ( RasGetErrorString( (UINT)dwRet, szMessage, 256 ) != 0 )
                wsprintf( (LPSTR)szMessage, "Undefined RasEnumEntries Error." );

        }

        if ( dwRet == 0 )  // No errors
        {
            for ( ndx = 0; ndx < cEntry; ndx++ ) 
                pLB->InsertString(-1,(LPCSTR) lpRasEntry[ndx].szEntryName);
//DYJ 1.05a Start
			if(m_bShowStar)
                pLB->InsertString(-1,STAR_TXT);
//DYJ  Ende; 

        }

        free( lpRasEntry );
    } 
    
#ifdef WIN16
    // for Win16, we require that the user enters their username
    ShowWindow( GetDlgItem( hdlg, IDC_USECURRENT ), SW_HIDE );
#endif


 
    return TRUE;
	return CDialog::OnInitDialog();
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}
